VIGRA - FFTWComplex class Reference

[ VIGRA Homepage | Class Index | Function Index | File Index | Main Page ]

| FFTWComplex Class Reference |
--- | --- | ---

Wrapper class for the FFTW type '`fftw_complex`'. More...

`#include "vigra/fftw3.hxx"`

## Public Types
typedef fftw_real | value_type
typedef fftw_real & | reference
typedef fftw_real const & | const_reference
typedef fftw_real * | iterator
typedef fftw_real const * | const_iterator
typedef fftw_real | NormType
typedef fftw_real | SquaredNormType
typedef fftw_real | value_type
typedef fftw_real & | reference
typedef fftw_real const & | const_reference
typedef fftw_real * | iterator
typedef fftw_real const * | const_iterator
typedef fftw_real | NormType
typedef fftw_real | SquaredNormType
## Public Methods
| FFTWComplex (value_type const &ire=0.0, value_type const &iim=0.0)
| FFTWComplex (FFTWComplex const &o)
| FFTWComplex (fftw_complex const &o)
template<class T> | FFTWComplex (TinyVector< T, 2 > const &o)
FFTWComplex & | operator= (FFTWComplex const &o)
FFTWComplex & | operator= (fftw_complex const &o)
FFTWComplex & | operator= (fftw_real const &o)
template<class T> FFTWComplex & | operator= (TinyVector< T, 2 > const &o)
FFTWComplex | operator- () const
SquaredNormType | squaredMagnitude () const
NormType | magnitude () const
value_type | phase () const
reference | operator[] (int i)
const_reference | operator[] (int i) const
int | size () const
| FFTWComplex (value_type const &re=0.0, value_type const &im=0.0)
| FFTWComplex (FFTWComplex const &o)
| FFTWComplex (fftw_complex const &o)
template<class T> | FFTWComplex (TinyVector< T, 2 > const &o)
FFTWComplex & | operator= (FFTWComplex const &o)
FFTWComplex & | operator= (fftw_complex const &o)
FFTWComplex & | operator= (fftw_real const &o)
template<class T> FFTWComplex & | operator= (TinyVector< T, 2 > const &o)
FFTWComplex | operator- () const
SquaredNormType | squaredMagnitude () const
NormType | magnitude () const
value_type | phase () const
reference | operator[] (int i)
const_reference | operator[] (int i) const
int | size () const

## Detailed Description

Wrapper class for the FFTW type '`fftw_complex`'.

This class provides constructors and other member functions for the C struct '`fftw_complex`'. This struct is the basic pixel type of the FFTW Fast Fourier Transform library. It inherits the data members '`re`' and '`im`' that denote the real and imaginary part of the number. In addition it defines transformations to polar coordinates, as well as arithmetic operators and accessors.

FFTWComplex implements the concepts AlgebraicField and DivisionAlgebra. The standard image types `FFTWRealImage` and `FFTWComplexImage` are defined.

See also:

- Numeric and Promote Traits of FFTWComplex
- Functions for FFTWComplex
- Accessors for FFTWComplex

#include "vigra/fftw3.hxx" (for FFTW 3) or
#include "vigra/fftw.hxx" (for deprecated FFTW 2)
Namespace: vigra

## Member Typedef Documentation

typedef fftw_real const* const_iterator

| const iterator type (result of begin() const)

typedef fftw_real const* const_iterator

| const iterator type (result of begin() const)

typedef fftw_real const& const_reference

| const reference type (result of operator[] const)

typedef fftw_real const& const_reference

| const reference type (result of operator[] const)

typedef fftw_real* iterator

| iterator type (result of begin() )

typedef fftw_real* iterator

| iterator type (result of begin() )

typedef fftw_real NormType

| The norm type (result of magnitde())

typedef fftw_real NormType

| The norm type (result of magnitde())

typedef fftw_real& reference

| reference type (result of operator[])

typedef fftw_real& reference

| reference type (result of operator[])

typedef fftw_real SquaredNormType

| The squared norm type (result of squaredMagnitde())

typedef fftw_real SquaredNormType

| The squared norm type (result of squaredMagnitde())

typedef fftw_real value_type

| The complex' component type, as defined in '`fftw3.h`'

typedef fftw_real value_type

| The complex' component type, as defined in '`fftw.h`'

## Constructor & Destructor Documentation

FFTWComplex | ( | value_type const & | ire = 0.0,
|  | value_type const & | iim = 0.0
| ) | `[inline]`

| Construct from real and imaginary part. Default: 0.

FFTWComplex | ( | FFTWComplex const & | o | ) | `[inline]`

| Copy constructor.

FFTWComplex | ( | fftw_complex const & | o | ) | `[inline]`

| Construct from plain `fftw_complex`.

FFTWComplex | ( | TinyVector< T, 2 > const & | o | ) | `[inline]`

| Construct from TinyVector.

FFTWComplex | ( | value_type const & | re = 0.0,
|  | value_type const & | im = 0.0
| ) | `[inline]`

| Construct from real and imaginary part. Default: 0.

FFTWComplex | ( | FFTWComplex const & | o | ) | `[inline]`

| Copy constructor.

FFTWComplex | ( | fftw_complex const & | o | ) | `[inline]`

| Construct from plain `fftw_complex`.

FFTWComplex | ( | TinyVector< T, 2 > const & | o | ) | `[inline]`

| Construct from TinyVector.

## Member Function Documentation

NormType magnitude | ( |  | ) | const`[inline]`

| Magnitude (length of radius vector).

NormType magnitude | ( |  | ) | const`[inline]`

| Magnitude (length of radius vector).

FFTWComplex operator- | ( |  | ) | const`[inline]`

| Unary negation.

FFTWComplex operator- | ( |  | ) | const`[inline]`

| Unary negation.

FFTWComplex& operator= | ( | TinyVector< T, 2 > const & | o | ) | `[inline]`

| Assignment.

FFTWComplex& operator= | ( | fftw_real const & | o | ) | `[inline]`

| Assignment.

FFTWComplex& operator= | ( | fftw_complex const & | o | ) | `[inline]`

| Assignment.

FFTWComplex& operator= | ( | FFTWComplex const & | o | ) | `[inline]`

| Assignment.

FFTWComplex& operator= | ( | TinyVector< T, 2 > const & | o | ) | `[inline]`

| Assignment.

FFTWComplex& operator= | ( | fftw_real const & | o | ) | `[inline]`

| Assignment.

FFTWComplex& operator= | ( | fftw_complex const & | o | ) | `[inline]`

| Assignment.

FFTWComplex& operator= | ( | FFTWComplex const & | o | ) | `[inline]`

| Assignment.

const_reference operator[] | ( | int | i | ) | const`[inline]`

| Read components as if number were a vector.

reference operator[] | ( | int | i | ) | `[inline]`

| Access components as if number were a vector.

const_reference operator[] | ( | int | i | ) | const`[inline]`

| Read components as if number were a vector.

reference operator[] | ( | int | i | ) | `[inline]`

| Access components as if number were a vector.

value_type phase | ( |  | ) | const`[inline]`

| Phase angle.

value_type phase | ( |  | ) | const`[inline]`

| Phase angle.

int size | ( |  | ) | const`[inline]`

| Length of complex number (always 2).

int size | ( |  | ) | const`[inline]`

| Length of complex number (always 2).

SquaredNormType squaredMagnitude | ( |  | ) | const`[inline]`

| Squared magnitude x*conj(x)

SquaredNormType squaredMagnitude | ( |  | ) | const`[inline]`

| Squared magnitude x*conj(x)

The documentation for this class was generated from the following files:

- vigra/fftw.hxx
- vigra/fftw3.hxx

© Ullrich Köthe (koethe@informatik.uni-hamburg.de) Cognitive Systems Group, University of Hamburg, Germany | html generated using doxygen and Python VIGRA 1.5.0 (7 Dec 2006)